###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$boardindexplver = "1 Gold - SP 1.3";


sub BoardIndex {
	require "$vardir/shoutbox_vars.pl";
	$shout_rowspan = ($username eq 'Guest') ? $shout_rowspan : $shout_rowspan - 2;
	# Load censor list.
	fopen(FILE,"$vardir/censor.txt");
	while( chomp( $buffer = <FILE> ) ) {
		($tmpa,$tmpb) = split(/=/,$buffer);
		push(@censored,[$tmpa,$tmpb]);
	}
	fclose(FILE);

	#RECENT USERS LIST MOD START
	if ($username ne 'Guest')
	{
		require "$sourcedir/LogInOut.pl";
		&RecentUsersList;
	}
	#RECENT USERS LIST MOD END
	# Open the file with all categories
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$yyCatsLoaded = 1;
	my($memcount, $latestmember) = &MembershipGet;
	$totalm = 0;
	$totalt = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		my($mscount);
		$mscount=0;
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
	while($MemStat[$mscount]) {
	if($settings[6] >= $MemPostNum[$mscount] && $MemPostNum[$mscount] ne "x") {
	$memberinfo = "$MemStat[$mscount]"; }
	++$mscount;
	}
	if ( $memberinfo eq $tmpa ) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter, $lastthreadid{$curboard} ) = &BoardCountGet($curboard);

			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}

	$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;
	#RECENT MEMBERS MOD START
	if ($rul_show_avatars && ($rul_avatar_width || $rul_avatar_height)) { $yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function resize_img(imgsrc, alttxt) {
	tmp_image = new Image;
	tmp_image.src = imgsrc;

	maxwidth = $rul_avatar_width;
	maxheight = $rul_avatar_height; 

	if (maxwidth != 0 && tmp_image.width > maxwidth) {
		tmp_image.height = (tmp_image.height * maxwidth / tmp_image.width);
		tmp_image.width = maxwidth;
	}
	if (maxheight != 0 && tmp_image.height > maxheight) {
		tmp_image.width = tmp_image.width * maxheight / tmp_image.height;
		tmp_image.height = maxheight;
	}

	document.write( '<img src="' + tmp_image.src + '" width="' + tmp_image.width + '" height="' + tmp_image.height + '" alt="' + alttxt + '" border="0" hspace="3">' )
}
// -->
</script>
~; }
	#RECENT MEMBERS MOD END

	$yymain .= qq~
<P align="left"><font size="1" class="nav"><IMG SRC="$imagesdir/open.gif" BORDER="0" alt=""> <b>$curforumurl</b></font>~;
	if($shownewsfader == 1) {
		if(!$fadedelay) { $fadedelay = 5000; }
		$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'102'}</b></font></td>
      </tr><tr>
        <td bgcolor="$color{'windowbg2'}" class="windowbg2" valign="middle" align="center" height="60">
<script language="JavaScript1.2" type="text/javascript">
<!--
var delay = $fadertime
var bcolor = "$color{'windowbg2'}"
var tcolor = "$color{'fadertext'}"
var fcontent = new Array()
begintag = '<font size="1"><B>'
~;
fopen(FILE, "$vardir/news.txt");
@newsmessages = <FILE>;
fclose(FILE);
for($i=0; $i < @newsmessages; $i++) {
	$newsmessages[$i] =~ s/\n|\r//g;
	if($i != 0){ $yymain .= qq~\n~; }
	$message = $newsmessages[$i];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	$message =~ s/\"/\\\"/g;
	$yymain .= qq~fcontent[$i] = "$message"~;
}
$yymain .= qq~
closetag = '</b></font>'
// -->
</script>
<script language="JavaScript1.2" type="text/javascript" src="$faderpath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
if (navigator.appVersion.substring(0,1) < 5 && navigator.appName == "Netscape") {
   var fwidth = screen.availWidth / 2;
   var bwidth = screen.availWidth / 4;
   document.write('<ilayer id="fscrollerns" width='+fwidth+' height=35 left='+bwidth+' top=0><layer id="fscrollerns_sub" width='+fwidth+' height=35 left=0 top=0></layer></ilayer>');
   window.onload = fade;
}
else if (navigator.userAgent.search(/Opera/) != -1 || (navigator.platform != "Win32" && navigator.userAgent.indexOf('Gecko') == -1)) {
   document.open();
   document.write('<div id="fscroller" style="width:90%; height:15px; padding:2px">');
   for(i=0; i < fcontent.length; ++i) {
      document.write(begintag+fcontent[i]+closetag+'<br>');
   }
   document.write('</div>');
   document.close();
   window.onload = fade;
}
else {
   document.write('<div id="fscroller" style="width:90% height:15px; padding:2px"></div>');
   window.onload = fade;
}
// -->
</script>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
	}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td>~;

	#Check to see if the subcat.txt doesn't exist, if it doesn't we still need a forum header or it looks funny
	if(!(-e "$vardir/subcat.txt"))
	{
		$yymain .= qq~
		<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		  <tr>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>Forum Name</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
		   </tr>
		  ~;
	}

	### snYpir's collapsable YaBB part 2
	# init catstatus counter
	my $catcount=0;
	if ( $username ne 'Guest' ){
		# load the .cat file for this user, put into array
		fopen(FILE, "$memberdir/$username.cat");
		@catstatus = <FILE>;
		fclose(FILE);

		# remove trailing newline chars
		for( $_ = 0; $_ < @catstatus; $_++ ) { chomp $catstatus[$_]; }

		# .cat file for this user not found, or number of categories changed?
		if ( @catstatus ne @categories ){
			# write new .cat file for user
			fopen( FILE, ">$memberdir/$username.cat", 1);
			for( $_ = 0; $_ < @categories; $_++ ) {
				print FILE "0\n";
			}
			fclose(FILE);
			fopen(FILE, "$memberdir/$username.cat");
			@catstatus = <FILE>;
			fclose(FILE);
			for( $_ = 0; $_ < @catstatus; $_++ ) { chomp $catstatus[$_]; }
		}
	}
	### end snYpir's collapsable YaBB part 2
	#This bit of code goes through and checks if we have visible categories. If there are no visible
	# categories, we need to still insert a <TABLE> string or else the info table will expand to full screen.
	$catisvisible="false";
	foreach $curcat (@categories)
	{
		unless( $openmemgr{$curcat} ) { next; }
		$catisvisible="true";
	}
	if($catisvisible eq "false")
	{
		$yymain .= qq~
		<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		~;
	}

	#Go through the categories and creat the tables if they are needed
	$foundasubcat="false";
	foreach $curcat (@categories)
	{
		unless( $openmemgr{$curcat} ) { next; }
		####
		if ($catpic{$curcat} =~ /\//i) {$catpic{$curcat} = qq~ <img src="$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		elsif ($catpic{$curcat}) {$catpic{$curcat} = qq~ <img src="$imagesdir/$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		####

		fopen(FILE, "$vardir/subcat.txt");
		@subcategories = <FILE>;
		fclose(FILE);
		$newsubcatlist="";

		#Go through the subcats and check to see if the curcat is found in the subcats file (It is a subcategory)
		foreach $cursubcat (@subcategories)
		{
			chomp($cursubcat);
			($cursubcatid,$cursubcatname) = split(/\|/,$cursubcat);
	
			#Check if we found a match
			if ($curcat eq $cursubcatid)
			{
				$foundasubcat="true";

				#This little code breaks the table away from the previous category
				if ($curcat ne @categories[0]) { $yymain .= qq~</TABLE><P>~; }

				 $yymain .= qq~
				    <table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
				      <tr>
~;
	### snYpir's collapsable YaBB part 1
	# expand/collapse all buttons
	if ( $username ne 'Guest' ){
		$yymain .= qq~
		<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2">
		<table>
		<tr>
		<td>
		<font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>
		</td>
		<td>
		<font class="text1" color="$color{'titletext'}" size="2"><b>  </b></font><a href=$scripturl?action=collapse_all;status=1><font size=2 class="text1" color="$color{'titletext'}"><b>$exptxt{'1'}</b></font></a></td>
		</td>
		<td>
		<font class="text1" color="$color{'titletext'}" size="2"><b>  </b></font><a href=$scripturl?action=collapse_all;status=0><font size=2 class="text1" color="$color{'titletext'}"><b>$exptxt{'2'}</b></font></a><font class="text1" color="$color{'titletext'}" size="2"><b>  </b></font></td>
		</td>
		</tr>
		</table>
		</td>~;
	}
	else{
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>~;
	}
	### end snYpir's collapsable YaBB part 1
$yymain .= qq~
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
				      </tr>
				~;
			}
		}

		#This code adds a table header for the very first category if the very first category is not found in subcat.txt
		if ((-e "$vardir/subcat.txt") && $foundasubcat eq "false")
		{
			$foundasubcat="true";
			$yymain .= qq~
			<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		  	  <tr>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>Forum Name</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
		   	  </tr>
		  	~;
		}
		$yymain .= qq~<tr>
	~;
	### snYpir's collapsable YaBB part 3
	if ( $username ne 'Guest' ) {
		my $newmsg = 0;
		my $new = "";
		# determine if there are new posts somewhere in this category
			foreach $curboard (@{$catboards{$curcat}}) {
				chomp $curboard;
				my $dlp = &getlog($curboard);
				if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
					$newmsg = 1; last;
				}
			if ( $newmsg ) { $new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~; }
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
		}
		if( $catstatus[$catcount] ) {
			$expandpic = qq~<img src="$imagesdir/minus.gif" border="0">~;}
		else {
			$expandpic = qq~<img src="$imagesdir/plus.gif" border="0">~;}
		$yymain .= qq~<td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18" onMouseOver="this.style.cursor='hand';" onclick="window.location.href='$scripturl?action=collapse_cat;forumnum=$catcount'"><a name="$curcat"> $catpic{$curcat}<font size=1>$expandpic $new $caticon<a href=$scripturl?action=collapse_cat;forumnum=$catcount><b>$catname{$curcat}</b></a> </font></td>~;
	}
	else {
		$yymain .= qq~<td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> $catpic{$curcat}<font size=1>&#171; $caticon<b>$catname{$curcat}</b></a> &#187;</font></td>~;
	}
	### end snYpir's collapsable YaBB part 3
	$yymain .= qq~
      </tr>~;
	### snYpir's collapsable YaBB part 4
	# if category is open, display boards (or if this user is a guest)
	if( $catstatus[$catcount] || $username eq 'Guest' ){
	### end snYpir's collapsable YaBB part 4
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			my $access = &AccessCheck($curboard, '');
			if ($settings[7] ne "Administrator" && $access ne "granted" && $showprivboards{$curboard} ne "1") {next;}
			fopen(FILE, "$boardsdir/$curboard.dat");
			$curboardname = <FILE>;
			chomp $curboardname;
			$curboarddescr = <FILE>;
			chomp $curboarddescr;
			$curboardmods = <FILE>;
			chomp $curboardmods;
			fclose(FILE);
			%moderators = ();
			foreach $curuser (split(/\|/, $curboardmods)) {
				&LoadUser($curuser);
				$moderators{$curuser} = $userprofile{$curuser}->[1];

			}
			$showmods = '';
			if(scalar keys %moderators == 1) { $showmods = qq~$txt{'298'}: ~; }
			elsif(scalar keys %moderators != 0) { $showmods = qq~$txt{'299'}: ~; }
			while($tmpa = each(%moderators)) {
				&FormatUserName($tmpa);
				$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
			}
			$showmods =~ s/, \Z//;
			if($showmods eq "") { $showmods = qq~$txt{'298'}: $txt{'470'}~; }
			$dlp = &getlog($curboard);
			if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
				$new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~;
			}
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
			$lastposter = $lastposter{$curboard};
			unless( $lastposterguest{$curboard} || $lastposter{$curboard} eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			$lastposter ||= $txt{'470'};
			$lastposttime ||= $txt{'470'};
			####
			$boardpic = "";
			if (-e "$boardsdir/$curboard.mbo" ) { require "$boardsdir/$curboard.mbo"; }
			if ($boardpic{$curboard} =~ /\//i) {$boardpic{$curboard} = qq~ <img src="$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}
			elsif ($boardpic{$curboard}) {$boardpic{$curboard} = qq~ <img src="$imagesdir/$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}

			my $cookiename = "$cookiepassword$curboard";
			my $crypass = crypt($boardpw{$curboard},$pwseed);
			my $boardpwpic = "";
			if ($settings[7] ne "Administrator" && $boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) {$boardpwpic = qq~<img border="0" alt="" align="absmiddle" src="$imagesdir/locking.gif">~;}
			elsif ($boardpw{$curboard}) {$boardpwpic = qq~<img border="0" align="absmiddle" alt="" src="$imagesdir/lockopen.gif">~;}
			####

			## LAST SUBJECT MOD ##

			#	Use the following line to decide if you want the Latest Subject in the Board Index to display the details
			#	(message icon, subject and link) of the FIRST post or LAST post of the most recently replied to thread

			$last_post = 1;		# 0 = FIRST post; 1 = LAST post

			$subjecthtml = "";
			if ($lastthreadid{$curboard}) {
				fopen(FILE,"$datadir/$lastthreadid{$curboard}.txt");
				@tmp_messages = <FILE>;
				fclose(FILE);
				if ($last_post) {$subjectmain = $tmp_messages[$#tmp_messages];} else {$subjectmain = $tmp_messages[0];} 
				($subjectmain, $dummy, $dummy, $dummy, $dummy, $subicon, $dummy) = split(/\|/, $subjectmain);

				# Censor the subject of the thread.
				foreach (@censored) {
					($tmpa,$tmpb) = @{$_};
					$subjectmain =~ s~\Q$tmpa\E~$tmpb~gi;
				}

				if (length($subjectmain) > 25) { $subjectmain = substr($subjectmain, 0, 25) . qq~ ...~; }
				$subicon = qq~<img src="$imagesdir/$subicon.gif" alt="" align="absmiddle">~;

				# Detect if this thread is a poll thread
				if (-e "$datadir/$lastthreadid{$curboard}.poll") {
					fopen (FILE, "$datadir/$lastthreadid{$curboard}.poll");
					$poll_question = <FILE>; 
					fclose (FILE);
					chomp $poll_question;
					($dummy, $poll_locked, $dummy) = split(/\|/, $poll_question, 3);
					$subicon = qq~$img{'pollicon'}~;
					if ($poll_locked eq "1" || $poll_locked eq "Locked") { $subicon = qq~$img{'polliconclosed'}~; }
				}
				if ($last_post) {$tmp_start = qq~;start=$#tmp_messages\#$#tmp_messages~;} else {$tmp_start = "";} 
				$subjecthtml = qq~$subicon <a href="$scripturl?board=$curboard;action=display;num=$lastthreadid{$curboard}$tmp_start">$subjectmain</a><br>~;
				if ($settings[7] ne "Administrator" && $boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) {$subjecthtml = qq~<img src="$imagesdir/locking.gif" alt="" align="absmiddle"> $mbco{'14'}<br>~;}
			}

			## END LAST SUBJECT MOD ##

			$yymain .= qq~<tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="8%" align="center" valign="top">$new</td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" width="66%">
        <font size="1"><a name="$curboard" href="$scripturl?board=$curboard">$boardpic{$curboard}<b>$curboardname $boardpwpic</b></a></font>
        <br><font size="1">$curboarddescr</font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="1">$threadcount{$curboard}</font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="1">$messagecount{$curboard}</font></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle" width="24%"><font size="1">$subjecthtml$lastposttime{$curboard}<BR>$txt{'525'} $lastposter</font></td>
      </tr>~;
		}
	### snYpir's collapsable YaBB part 5
	}
	++$catcount;
	### end snYpir's collapsable YaBB part 5
	}
	my $checkadded = 0;
	$guests = 0;
	$users = '';
	$numusers = 0;
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
		if($name) {
			if(!$yyUDLoaded{$musername}) { &LoadUser($name); }
			if(exists $userprofile{$name}) {
				$numusers++;
				$users .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size="1">,</font> \n~;
			}
			else { $guests++; $guest_ip .= $name . qq~<font size="1">,</font> \n~;}
		}
	}
	$users =~ s~<font size="1">,</font> \n\Z~~;
	$guest_ip =~ s~<font size="1">,</font> \n\Z~~;
	if($username ne 'Guest') {
		$ims = @immessages;
### LIMITED IM MOD ###
if($userimcfg[5] eq "on") {
$yymain .= qq~<script language="javascript"> function viewinstant() { window.open("$scripturl?action=im") } </script>~; }
else {
$yymain .= qq~<script language="javascript"> function viewinstant() { location.href = ("$scripturl?action=im") } </script>~; }

if ($minnum > $numibox && $numibox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $minnum $imtxt{'12'} $txt{'316'}!\\n$numibox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IM; 
}

if ($moutnum > $numobox && $numobox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $moutnum $imtxt{'12'} $txt{'320'}!\\n$numobox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IMOUT; 
}

if ($storenum > $numstore && $numstore ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $storenum $imtxt{'12'} $imtxt{'46'}!\\n$numstore $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_STORE; 
}

$ims = qq~<BR>$txt{'796'} <a href="$scripturl?action=im"><B>$ims</B></a> $imtxt{'24'}: <a href="$scripturl?action=im"><B>$imnewcount</B></a>~;

### END LIMITED IM ###
		$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="6" align="center">
        <table cellpadding="0" border="0" cellspacing="0" width="100%">
          <tr>
            <td align="left"> <font size="1" color="#ffffff">
            <img src="$imagesdir/on.gif" border=0 alt="$txt{'333'}"> $txt{'333'}&nbsp;&nbsp;
            <img src="$imagesdir/off.gif" border=0 alt="$txt{'334'}"> $txt{'334'}</font></td>
            <td align="right"><font size=1>&nbsp;
~;
	if($showmarkread) { $yymain .= qq~<a href="$scripturl?action=markallasread">$img{'markallread'}</a>~; }
	$yymain .= qq~
            </font></td>
          </tr>
        </table>
        </td>
      </tr>~;
	}

	#set the correct rowspan for the recent users list main cell
	#this setting works with the standard yabb info centre (rowspan 6 for guests, 4 when logged in)
	$rul_rowspan = ($username eq 'Guest') ? 7 : 4;

	#the following add-on compatibility settings aren't guaranteed to work because most of these mods don't have specific settings to let us know whether anything has been added to the info centre
	#the compromise is to check if a variable used by these mods exists, and if so presume the mod has been added to the info centre

	#compatibility with the New Calendar mod by Ironwing, GauGau, & Nermware
	if ($newcalspread || $newcalindexmini) { $rul_rowspan += 2; }
	#compatibility with the Calendar mod by Matthew Throesch
	if ($calindex == 1) { $rul_rowspan += 2; }
	#compatibility with the MSN Messenger mod by Omario
	if (-e("$imagesdir/msn.gif")) { $rul_rowspan += 2; }
	#compatibility with the Top Threads mod by CoolMan25
	if ($tttxt{'01'}) { $rul_rowspan += 2; }
	#compatibility with the Forum Staff Info mod by BHRA Webmaster
	if ($forum_staff) { $rul_rowspan += 2; }
	#compatibility with the Countdown mod by Matthew Throesch
	if (-e("$vardir/countdown.txt")) { $rul_rowspan += 2; }
	#compatibility with the YaBB Chat! for YaBB Gold SP1 mod by _Max, Omario, Samm
	if (-e("$vardir/ChatSettings.txt"))
	{
		require "$vardir/ChatSettings.txt";

		chomp $chatgroup;
		@chatgrouplist = split(",",$chatgroup);
		$chatgroupflag = 0;
		foreach $chatgroupitem (@chatgrouplist)
		{
			if ($settings[7] eq $chatgroupitem) { $chatgroupflag = 1; }
		}

		if ($chatopen == 1 || $chatgroupflag == 1 || ($chatopen == 0 && $settings[7] eq 'Administrator')) { $rul_rowspan += 2; }
	}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
<BR><BR>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
<tr> 
<td bgcolor="$color{'titlebg'}" class="titlebg" align="center"> 
<font class="text1" color="$color{'titletext'}" size="2"><b>$shout_txt{'5'}</b></font></td> 
<td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2"> 
<font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'685'}</b></font></td> 
<td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2"> 
<font class="text1" color="$color{'titletext'}" size="2"><b>$rul_users_display $lud_txt{'1'}</b></font></td> 
</tr> 
<tr> 
<td rowspan="$shout_rowspan" class="windowbg2" bgcolor="$color{'windowbg'}" valign="top" width="1%">~; 

require "$sourcedir/Shoutbox.pl"; 
&ShoutBox; 

$yymain .= qq~ 
<td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="1" class="catbg"><b>$txt{'200'}</b></font></td>
		<td rowspan="$rul_rowspan" class="windowbg2" bgcolor="$color{'windowbg'}" valign="top" width="25%">~;
	  
	&RecentUsersListShow;
	
	$yymain .= qq~
      </td></tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/info.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="top" align="center"><font size="1">
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left" width="60%"><font size="1">
            $txt{'490'} <B>$totalt</B> &nbsp; - &nbsp; $txt{'489'} <B>$totalm</B>
	    ~;
	if($Show_RecentBar) {
		require "$sourcedir/Recent.pl";
		&LastPost;
	}
	$yymain .= qq~
	    </font></td>
	  </tr>
	</table>
	</font></td>
	~;
	if($totalt > 0) {
		require "$sourcedir/TopStats.pl";
		&TopLink;
	}
	$yymain .= qq~
      </tr><tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="1" class="catbg"><b>$txt{'158'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">
            $guests $txt{'141'}~;
		if ($guest_ip) { $yymain .= qq~ ($guest_ip)~; } 
		$yymain .= qq~, $numusers $txt{'142'}<BR>$users
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
########### Newcalendar mod start #######################
	chomp $newcalgroup;
	@newcalgrouplist = split(",",$newcalgroup);
	$newcalgroupflag = 0;
	foreach $newcalgroupitem (@newcalgrouplist) {
		if ($settings[7] eq $newcalgroupitem) { $newcalgroupflag = 1; }
	}
if ($newcalopen == 1 || $settings[7] eq 'Administrator' || $newcalgroupflag ==1 ) {
	if ($newcalmoon2 == 1) {
		require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
		( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
		my ($newphaselow) = 0.016666667;
		my ($newphasehigh) = 0.983333333;
		my ($phaseincrement) = 0.033333333;

		if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
			$moonpict = qq~<img src="$imagesdir/moon00.gif" alt="" border="0">~;
		} else {
			$gifnumber = 1;
			for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
				if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
					if ($gifnumber < 10) {
						$moonpict = qq~<img src="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
					} else {
						$moonpict = qq~<img src="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
					}
				}
				$gifnumber++;
			}
		}
	} else {
		$moonpict = qq~<img src="$imagesdir/newcal.gif" alt="" border="0">~;
	}
	$yymain .=qq~
       <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="1" class="catbg"><b>$ecaltxt{'55'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><a href="$cgi;action=newcalendar">$moonpict</a></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">~;
require "$sourcedir/NewcalIndex.pl";
if ($newcalindexmini == 1) {
	$yymain .=qq~
<table width='100%'>
  <tr>
    <td valign='top'>
      <font size="1">~;
        &IndexCal;
	$yymain .=qq~
      </font>
    </td><td align='right'>~;
	require "$sourcedir/NewcalPost.pl";
      &MiniCalYY;
      $yymain .=qq~$yyminical~;
	$yymain .=qq~
    <td>
  </tr>
</table>~;
} else {
	&IndexCal;
}
$yymain .=qq~  
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
}
########### Newcalendar mod end #######################
	if($username eq 'Guest') {
		require "$sourcedir/LogInOut.pl";
		$sharedLogin_title="$txt{'34'} <small><a href=\"$cgi;action=reminder\">($txt{'315'})</a></small>";
		&sharedLogin;
	}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
~;
	if($imnewcount > 0 && $enable_mailpopup == 1) {
		if($imnewcount > 1) { $en = "s"; $en2 = "$imtxt{'47'}"; } else { $en = ""; $en2 = "$imtxt{'48'}"; }

		open(FILE, "$memberdir/$username.imconfig");
		@imuserdata = <FILE>;
		close(FILE);

		chomp($imuserdata[3]);
		chomp($imuserdata[5]);

		if($imuserdata[3] eq "on") {
	if($imuserdata[5] eq "on") {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { window.open("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	} else {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { location.href = ("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	}
		$yymain .= qq~
	<script language="JavaScript">
	<!-- BEGIN
		if (confirm("$imtxt{'13'} $imnewcount $imtxt{'14'}$en$imtxt{'15'} $en2?")) { rimpu(); } else cancel()
	// END --> 
	</script>
		~;
		}
	}
	$yytitle = "$txt{'18'}";
	&template;
	exit;
}

#RECENT USERS LIST
#v1.2.4
#OUTPUTS A TABLE WITH $rul_users_display ROWS - ONE FOR EACH USER IN THE LIST
sub RecentUsersListShow
{
	fopen(FILE, "$vardir/lastuseronline.txt"); @lastusers = <FILE>; fclose(FILE); chomp @lastusers;
	$counter = 1;
	
	$yymain .= qq~<table border="0" cellspacing="0" cellpadding="3">~;
	
	foreach $lastuser_line (@lastusers)
	{
		($last_username, $last_userwhen) = split(/\|/, $lastuser_line);

		#is this user online now?
		$online_now = ($users =~ /username=$last_username"/) ? "<br>$lud_txt{'2'}" : '';

		#it should never happen, but a Guest entry might have been stored in the file. this avoids showing it 
		if (fopen(MFILE, "$memberdir/$last_username.dat"))
		{
			@memberinfo = <MFILE>; fclose(MFILE); chomp @memberinfo;
			$last_userwhen = &timeformat($last_userwhen) || $last_userwhen;

			#do we want to show an avatar?
			if ($rul_show_avatars)
			{
				#correct url allowing for custom avatars
				if ($memberinfo[13] =~ m~\Ahttp://~) { $avatar = $memberinfo[13]; }
				else { $avatar = $facesurl . '/' . $memberinfo[13]; }
			
				#is resizing enabled or shall we just show a plain image tag?
				#if we're using avatar resizing
				if ($rul_avatar_width || $rul_avatar_height)
				{
					#decide what the avatar link should be
					if ($rul_avatar_link == 2) { $avatars_cell = qq~<td><a href="$cgi;action=imsend;to=$last_username">\n<script language="JavaScript1.2" type="text/javascript"><!--\nresize_img("$avatar", "$lud_txt{'12'} $memberinfo[1]")\n--></script>\n</a></td>~; }
					elsif ($rul_avatar_link == 1) { $avatars_cell = qq~<td><a href="$cgi;action=viewprofile;username=$last_username">\n<script language="JavaScript1.2" type="text/javascript"><!--\nresize_img("$avatar", "$lud_txt{'13'} $memberinfo[1]")\n--></script>\n</a></td>~; }
					else { $avatars_cell = qq~<td>\n<script language="JavaScript1.2" type="text/javascript"><!--\nresize_img("$avatar", "$memberinfo[1]")\n--></script>\n</td>~; }
				}
				#else we're not using resizing so just use the normal image tag
				else
				{
					#decide what the avatar link should be
					if ($rul_avatar_link == 2) { $avatars_cell = qq~<td><a href="$cgi;action=imsend;to=$last_username"><img src="$avatar" border="0" alt="$lud_txt{'12'} $memberinfo[1]" hspace="3"></a></td>~; }
					elsif ($rul_avatar_link == 1) { $avatars_cell = qq~<td><a href="$cgi;action=viewprofile;username=$last_username"><img src="$avatar" border="0" alt="$lud_txt{'13'} $memberinfo[1]" hspace="3"></a></td>~; }
					else { $avatars_cell = qq~<td><img src="$avatar" border="0" alt="$memberinfo[1]" hspace="3"></td>~; }
				}
			}
			#else we're not showing avatars, so just show the text counter
			else { $avatars_cell = qq~<td valign="top"><font size="1">$counter.</font></td>~; }

			#output this row
			$yymain .= qq~<tr>$avatars_cell<td><font size="1"><a href="$cgi;action=viewprofile;username=$last_username">$memberinfo[1]</a><br>$last_userwhen$online_now</font></td></tr>~;
			}

			$counter++;
	}

	$yymain .= qq~</table>~;
}



### snYpir's collapsable YaBB - subs
sub Collapse_Cat {
	my ($catindex,@catstatus);

	if ( $username eq 'Guest' ){
		&fatal_error($exptxt{'4'});
		exit;            
	}

	# Grab the index of the category to collapse/expand
	$catindex = $INFO{'forumnum'};

	# read the current users category file
	fopen(FILE, "$memberdir/$username.cat");
	@catstatus = <FILE>;
	fclose(FILE);
	chomp @catstatus;

	# does the file exist?
	if ( $catstatus[0] != 1 && $catstatus[0] != 0 ){
		&fatal_error($exptxt{'3'});
		exit;
	}

	# toggle the status of the selected category
	if ( $catstatus[$catindex] eq 1 ){
		$catstatus[$catindex] = 0;
	}
	else{
		$catstatus[$catindex] = 1;
	}

	# rewrite category file for this user
	fopen( FILE, ">$memberdir/$username.cat", 1);
	for( $_ = 0; $_ < @catstatus; $_++ ) { print FILE "$catstatus[$_]\n"; }
	fclose(FILE);

	&redirectinternal;
	exit;   
}

sub Collapse_All {
	my ($state,@catstatus);

	$state = $INFO{'status'};

	if ( $username eq 'Guest' ){
		&fatal_error($exptxt{'4'});
		exit;            
	}   

	# read the current users category file
	fopen(FILE, "$memberdir/$username.cat");
	my @catstatus = <FILE>;
	fclose(FILE);
	chomp @catstatus;   

	# does the file exist?
	if ( $catstatus[0] != 1 && $catstatus[0] != 0 ){
		&fatal_error($exptxt{'3'});
		exit;
	}   

	# rewrite category file for this user
	fopen( FILE, ">$memberdir/$username.cat", 1);
	for( $_ = 0; $_ < @catstatus; $_++ ) { print FILE "$state\n"; }
	fclose(FILE);   

	&redirectinternal;
	exit;  
}
### end snYpir's collapsable YaBB - subs

sub MarkAllRead {
	fopen(FILE, "$vardir/cat.txt");
	my @categories = <FILE>;
	fclose(FILE);
	my( $curcat, $curcatname, $curcataccess, @catboards, @membergroups, $openmemgr, $curboard );
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		chomp $curcatname;
		chomp $curcataccess;
		@catboards = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $curcataccess );
		$openmemgr = 0;
		foreach (@membergroups) {
			if( $_ eq $settings[7]) { $openmemgr = 1; last; }
		}
		if(!$curcataccess || $settings[7] eq 'Administrator') { $openmemgr = 1; }
		unless( $openmemgr ) { next; }
		foreach $curboard (@catboards) {
			chomp $curboard;
			&modlog("$curboard--mark");
			&modlog($curboard);
		}
	}
	&dumplog;
	&BoardIndex;
}

1;